/*
 * mainpref.js
 * 
 * Copyright (c) 1997 Netscape Communications Corporation, All Rights Reserved
 * 
 * Functions that manage the options dialog
 */

var selectorControls = opener;
var tabShowing = "";

var selectorDrawer = selectorControls.GetSelectorWindow();
var selectorTab = selectorDrawer.GetSelectorTab();

function HandleOK() {
	var	boolValue = false;

	// Process the display characteristics
	
	var layout_form = self.document.layers['layout'].document.layout_form;
	var security_form = self.document.layers['security'].document.security_form;

	boolValue	= security_form.marimbaCookies.checked;
	depth.SetNetscapePrefBool("netcaster.castanet.acceptCookies", boolValue)

	boolValue	= security_form.marimbaLogging.checked;
	depth.SetNetscapePrefBool("netcaster.castanet.loggingEnabled", boolValue)

	boolValue	= security_form.marimbaProfiling.checked;
	depth.SetNetscapePrefBool("netcaster.castanet.profileEnabled", boolValue)

	if (window.layoutLoaded) {
		var drawerPos = layout_form.drawerPos.options[layout_form.drawerPos.selectedIndex].value;
	//	var webtopPos = layout_form.webtopPos.options[layout_form.webtopPos.selectedIndex].value;
		var webtopPos = "left";
		boolValue = layout_form.autoHide.checked;

		depth.SetNetscapePref("netcaster.drawer.dock", drawerPos)
		depth.SetNetscapePref("netcaster.webtopDock", webtopPos)
		if (boolValue == true) {
			depth.SetNetscapePref("netcaster.drawer.autoHide", "true")
		} else {
			depth.SetNetscapePref("netcaster.drawer.autoHide", "false")
		}

		// only fix these if we've loaded the defaults in (i.e., the user's seen them)
		var useDefault = layout_form.onDefault[1].checked;
		
		if (useDefault) {
			var defaultChannelIndex = layout_form.defaultChannel.selectedIndex;
			var defaultChannelItem = layout_form.defaultChannel.options[defaultChannelIndex].prototype;

			depth.SetNetscapePref("netcaster.defaultChannel", defaultChannelItem.getPrefsName())
		} else {
			depth.SetNetscapePref("netcaster.defaultChannel", "");
		}
		

		selectorTab.PositionSelector();

		// DesktopMgr.WebtopPosition("left/right");

	}

	self.close();
}

function HandleHelp() {
	selectorControls.HandleHelp("customizing_Netcaster");
}

function PropertiesCallback(editWindow) {
	if (gTabShowing != "")
		document.layers[gTabShowing].PropertiesCallback(editWindow);
}

function EditCallback(editWindow) {
	if (gTabShowing != "")
		document.layers[gTabShowing].EditCallback(editWindow);
}

void(0);